module Planik
  module Arbeitszeitkonto
  ##
  # Feiertag
  ##
  class FeiertagZeitkontoCalculator < ZeitkontoCalculator


    ##
    # @feiertage: Array von Dates
    # @zeit_von, @zeit_bis: Times für die Zeitangaben
    # @start_tag: Wann die Feiertagzeitspanne beginnt. Es kann ja sein, dass sie am Tag vorher beginnt
    ##
    def initialize feiertage, zeit_von, zeit_bis, start_tag = 0
      @feiertage_zeitspannen = create_feiertage_zeitspannen(feiertage, zeit_von, zeit_bis, start_tag)
    end



    def calculate zeitspannen
      calc(Array(zeitspannen), @feiertage_zeitspannen)
    end


    private

    ##
    # Erstellt für jeden Feiertag eine Zeitspanne
    ##
    def create_feiertage_zeitspannen feiertage, zeit_von, zeit_bis, start_tag
      anzahl_tage_dazwischen = (zeit_bis.to_date - zeit_von.to_date).to_i
      feiertage.map do |f|
        f = f + start_tag.days
        Zeitspanne.new(kombiniere(f, zeit_von), kombiniere(f, zeit_bis)+anzahl_tage_dazwischen.days)
      end
    end

  end
end
end
